"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
/**
 *
 */
function array(_a) {
    var _b = _a === void 0 ? {
        required: true,
        nullable: false,
    } : _a, required = _b.required, nullable = _b.nullable;
    required = required !== undefined ? required : true;
    nullable = nullable !== undefined ? nullable : false;
    return function (target, name
    // descriptor: PropertyDescriptor
    ) {
        //
        var wrap = utils_1.wrapSchema(target);
        if (wrap.properties !== undefined && name in wrap.properties === false) {
            throw new TypeError('@array() must be used with other @props method');
        }
        if (nullable) {
            wrap.properties[name] = {
                anyOf: [
                    {
                        type: 'array',
                        items: wrap.properties[name],
                    },
                    { type: 'null' },
                ],
            };
        }
        else {
            wrap.properties[name] = {
                type: 'array',
                items: wrap.properties[name],
            };
        }
    };
}
exports.default = array;
//# sourceMappingURL=array.js.map